
class NewThread implements Runnable
{
	String name; // name of thread
	Thread t;

	NewThread(String threadname)
	{
		name = threadname;
		t = new Thread(this, name);
		System.out.println("New thread: " + t);
		t.start(); // Start the thread
	}

	public void run()
	{
		try
		{
			for (int i = 3; i > 0; i--)
			{
				System.out.println(name + ": " + i);
				Thread.sleep(1000);
			}
		}
		catch (InterruptedException e)
		{
			System.out.println(name + " interrupted.");
		}
		System.out.println(name + " exiting.");
	}
}

class DemoJoin
{
	public static void main(String args[])
	{
		int i;
		NewThread[] obs = new NewThread[1000];
		for(i = 0; i < 1000; i++)
			obs[i] = new NewThread("T" + (i + 1));
		for(i = 0; i < 1000; i++)
			System.out.println("T" + (i + 1) + " is alive: " + obs[i].t.isAlive());
		try
		{
			System.out.println("Waiting for threads to finish.");
			for(i = 0; i < 1000; i++)
				obs[i].t.join();
		}
		catch (InterruptedException e)
		{
			System.out.println("Main thread Interrupted");
		}
		for(i = 0; i < 1000; i++)
			System.out.println("T" + (i + 1) + " is alive: " + obs[i].t.isAlive());
		System.out.println("Main thread exiting.");
	}
}
