
import utils.User;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.EOFException;
import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;

public class TCPClient
{
	public static void main(String args[])
	{
		String texto;
		Socket s = null;
		int serversocket = 6000;
		try
		{
			// 1o passo
			s = new Socket(args.length > 0 ? args[0] : "localhost", serversocket);
			if (s == null)
				System.out.println("NAO CONSEGUIU CRIAR O SOCKET");

			// 2o passo
			DataInputStream in = new DataInputStream(s.getInputStream());
			DataOutputStream out =
					new DataOutputStream(s.getOutputStream());

			System.out.println("Introduza texto:");

			// 3o passo
			while (true)
			{
				texto = User.readString();
				out.writeUTF(texto);
				String data = in.readUTF();
				System.out.println("Received: " + data);
				out.flush();
			}
		}
		catch (UnknownHostException e)
		{
			System.out.println("Sock:" + e.getMessage());
		}
		catch (EOFException e)
		{
			System.out.println("EOF:" + e.getMessage());
		}
		catch (IOException e)
		{
			System.out.println("IO:" + e.getMessage());
		}
		finally
		{
			if (s != null)
				try
				{
					s.close();
				}
				catch (IOException e)
				{
					System.out.println("close:" + e.getMessage());
				}
		}
	}
}