
import utils.User;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.EOFException;
import java.io.IOException;
import java.net.Socket;
import java.net.UnknownHostException;

public class TCPClientBench
{
	public static void main(String args[])
	{
        int n;
		Socket s = null;
		int serversocket = 6000;
		try
		{
			// 1o passo
			s = new Socket(args.length > 0 ? args[0] : "localhost", serversocket);
			if (s == null)
				System.out.println("NAO CONSEGUIU CRIAR O SOCKET");

			// 2o passo
			DataInputStream in = new DataInputStream(s.getInputStream());
			DataOutputStream out =
					new DataOutputStream(s.getOutputStream());

			System.out.println("Introduza n:");

			int[] lengths = {4, 512, 1024, 2048, 4096, 8192, 16384, 32768};
			n = User.readInt();
			int i;
			long inicio, fim;
			String string;
			for(int j = 0; j < lengths.length; j++)
			{
				string = new String(new char[lengths[j]]);
				inicio = System.currentTimeMillis();
				for(i = 0; i < n; i++)
				{
					out.writeUTF(string);
					in.readUTF();
				}
				fim = System.currentTimeMillis();
				System.out.println(lengths[j] + ": " + ((fim-inicio) / (double)n));
			}
		}
		catch (UnknownHostException e)
		{
			System.out.println("Sock:" + e.getMessage());
		}
		catch (EOFException e)
		{
			System.out.println("EOF:" + e.getMessage());
		}
		catch (IOException e)
		{
			System.out.println("IO:" + e.getMessage());
		}
		finally
		{
			if (s != null)
				try
				{
					s.close();
				}
				catch (IOException e)
				{
					System.out.println("close:" + e.getMessage());
				}
		}
	}
}