// TCPServer2.java: Multithreaded server

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.EOFException;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;

public class TCPServer2
		{
	public static void main(String args[])
	{
		int numero = 0;

		try
		{
			int serverPort = 6000;
			System.out.println("A Escuta no Porto 6000");
			ServerSocket listenSocket = new ServerSocket(serverPort);
			while (true)
			{
				Socket clientSocket = listenSocket.accept();
				numero++;
				new Connection(clientSocket, numero);
			}
		}
		catch (IOException e)
		{
			System.out.println("Listen:" + e.getMessage());
		}
	}
}

//= Thread para tratar de cada canal de comunicao com um cliente

class Connection extends Thread
{
	DataInputStream in;
	DataOutputStream out;
	Socket clientSocket;
	int thread_number;

	public Connection(Socket aClientSocket, int numero)
	{
		thread_number = numero;
		try
		{
			clientSocket = aClientSocket;
			in = new DataInputStream(clientSocket.getInputStream());
			out = new DataOutputStream(clientSocket.getOutputStream());
			this.start();
		}
		catch (IOException e)
		{
			System.out.println("Connection:" + e.getMessage());
		}
	}
//=============================
	public void run()
	{
		String resposta;
		try
		{
			while (true)
			{
				//an echo server
				String data = in.readUTF();
				System.out.println("T[" + thread_number + "] Recebeu: " + data);
				resposta = data.toUpperCase();
				out.writeUTF(resposta);
			}
		}
		catch (EOFException e)
		{
			System.out.println("EOF:" + e);
		}
		catch (IOException e)
		{
			System.out.println("IO:" + e);
		}
	}
}