// TCPServer2.java: Multithreaded server

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.EOFException;
import java.io.IOException;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.StringTokenizer;

public class TCPServerCalc
		{
	public static void main(String args[])
	{
		int numero = 0;

		try
		{
			int serverPort = 6000;
			System.out.println("A Escuta no Porto 6000");
			ServerSocket listenSocket = new ServerSocket(serverPort);
			while (true)
			{
				new CalcConnection(listenSocket.accept(), ++numero);
			}
		}
		catch (IOException e)
		{
			System.out.println("Listen:" + e.getMessage());
		}
	}
}

//= Thread para tratar de cada canal de comunicao com um cliente

class CalcConnection extends Thread
{
	DataInputStream in;
	DataOutputStream out;
	Socket clientSocket;
	int thread_number;

	public CalcConnection(Socket aClientSocket, int numero)
	{
		thread_number = numero;
		try
		{
			clientSocket = aClientSocket;
			in = new DataInputStream(clientSocket.getInputStream());
			out = new DataOutputStream(clientSocket.getOutputStream());
			this.start();
		}
		catch (IOException e)
		{
			System.out.println("Connection:" + e.getMessage());
		}
	}
//=============================
	public void run()
	{
		String resposta, data;
		try
		{
			while (true)
			{
				//an echo server
				data = in.readUTF();
				System.out.println("T[" + thread_number + "] Recebeu: " + data);
				resposta = calc(data);
				out.writeUTF(resposta);
				out.flush();
			}
		}
		catch (EOFException e)
		{
			System.out.println("EOF:" + e);
		}
		catch (IOException e)
		{
			System.out.println("IO:" + e);
		}
	}

	private String calc(String data)
	{
		StringTokenizer tokens = new StringTokenizer(data, "+*-/", true);
		if (tokens.countTokens() != 3)
			return "unknown operation";
		double num1 = Double.parseDouble(tokens.nextToken());
		char sinal = tokens.nextToken().charAt(0);
		double num2 = Double.parseDouble(tokens.nextToken());
		switch(sinal)
		{
			case '+': return "" + (num1 + num2);
			case '-': return "" + (num1 - num2);
			case '*': return "" + (num1 * num2);
			case '/':
				if (num2 == 0)
					return "Division by 0";
				else
					return "" + (num1 / num2);
			default: return "unknown operation";
		}
	}
}