
import utils.User;

import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.InetAddress;
import java.net.SocketException;

public class UDPClientBench
		{
	public static void main(String args[])
	{

		// argumentos da linha de comando: hostname
		DatagramSocket aSocket = null;
		try
		{
			aSocket = new DatagramSocket();

			System.out.println("Introduza n:");

			int[] lengths = {4, 512, 1024, 2048, 4096, 8192, 16384, 32768};
			int n = User.readInt();
			int i;
			long inicio, fim;

			DatagramPacket request;
			InetAddress aHost = InetAddress.getByName(args.length > 0 ? args[0] : "localhost");
			int serverPort = 6789;
			for(int j = 0; j < lengths.length; j++)
			{
				request = new DatagramPacket(new byte[lengths[j]], lengths[j], aHost, serverPort);
				inicio = System.currentTimeMillis();
				for(i = 0; i < n; i++)
				{
					aSocket.send(request);
					aSocket.receive(request);
				}
				fim = System.currentTimeMillis();
				System.out.println(lengths[j] + ": " + ((fim-inicio) / (double)n));
			}
		}
		catch (SocketException e)
		{
			System.out.println("Socket: " + e.getMessage());
		}
		catch (IOException e)
		{
			System.out.println("IO: " + e.getMessage());
		}
		finally
		{
			if (aSocket != null) aSocket.close();
		}
	}
}