
import java.io.IOException;
import java.net.DatagramPacket;
import java.net.DatagramSocket;
import java.net.SocketException;
import java.util.StringTokenizer;

public class UDPServerCalc
		{
	public static void main(String args[])
	{
		DatagramSocket aSocket = null;
		String s;
		try
		{
			aSocket = new DatagramSocket(6789);
			System.out.println("Socket Datagram  escuta no porto 6789");
			while (true)
			{
				byte[] buffer = new byte[1000];
				DatagramPacket request = new DatagramPacket(buffer, buffer.length);
				aSocket.receive(request);
				s = new String(request.getData()).substring(0, request.getLength());
				System.out.println("Server Recebeu: " + s);

				s=calc(s);
				System.out.println("Server calculou: " + s);

				DatagramPacket reply = new DatagramPacket(s.getBytes(), s.getBytes().length, request.getAddress(), request.getPort());
				aSocket.send(reply);
			}
		}
		catch (SocketException e)
		{
			System.out.println("Socket: " + e.getMessage());
		}
		catch (IOException e)
		{
			System.out.println("IO: " + e.getMessage());
		}
		finally
		{
			if (aSocket != null) aSocket.close();
		}
	}
	private static String calc(String data)
	{
		StringTokenizer tokens = new StringTokenizer(data, "+*-/", true);
		if (tokens.countTokens() != 3)
			return "unknown operation";
		double num1 = Double.parseDouble(tokens.nextToken());
		char sinal = tokens.nextToken().charAt(0);
		double num2 = Double.parseDouble(tokens.nextToken());
		switch(sinal)
		{
			case '+': return "" + (num1 + num2);
			case '-': return "" + (num1 - num2);
			case '*': return "" + (num1 * num2);
			case '/':
				if (num2 == 0)
					return "Division by 0";
				else
					return "" + (num1 / num2);
			default: return "unknown operation";
		}
	}
}